package com.hfkj.entity;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

public class BsOrderDeductionExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    private Integer limit;

    private Long offset;

    public BsOrderDeductionExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    public void setLimit(Integer limit) {
        this.limit = limit;
    }

    public Integer getLimit() {
        return limit;
    }

    public void setOffset(Long offset) {
        this.offset = offset;
    }

    public Long getOffset() {
        return offset;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andOrderIdIsNull() {
            addCriterion("order_id is null");
            return (Criteria) this;
        }

        public Criteria andOrderIdIsNotNull() {
            addCriterion("order_id is not null");
            return (Criteria) this;
        }

        public Criteria andOrderIdEqualTo(Long value) {
            addCriterion("order_id =", value, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdNotEqualTo(Long value) {
            addCriterion("order_id <>", value, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdGreaterThan(Long value) {
            addCriterion("order_id >", value, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdGreaterThanOrEqualTo(Long value) {
            addCriterion("order_id >=", value, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdLessThan(Long value) {
            addCriterion("order_id <", value, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdLessThanOrEqualTo(Long value) {
            addCriterion("order_id <=", value, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdIn(List<Long> values) {
            addCriterion("order_id in", values, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdNotIn(List<Long> values) {
            addCriterion("order_id not in", values, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdBetween(Long value1, Long value2) {
            addCriterion("order_id between", value1, value2, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdNotBetween(Long value1, Long value2) {
            addCriterion("order_id not between", value1, value2, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderNoIsNull() {
            addCriterion("order_no is null");
            return (Criteria) this;
        }

        public Criteria andOrderNoIsNotNull() {
            addCriterion("order_no is not null");
            return (Criteria) this;
        }

        public Criteria andOrderNoEqualTo(String value) {
            addCriterion("order_no =", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoNotEqualTo(String value) {
            addCriterion("order_no <>", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoGreaterThan(String value) {
            addCriterion("order_no >", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoGreaterThanOrEqualTo(String value) {
            addCriterion("order_no >=", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoLessThan(String value) {
            addCriterion("order_no <", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoLessThanOrEqualTo(String value) {
            addCriterion("order_no <=", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoLike(String value) {
            addCriterion("order_no like", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoNotLike(String value) {
            addCriterion("order_no not like", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoIn(List<String> values) {
            addCriterion("order_no in", values, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoNotIn(List<String> values) {
            addCriterion("order_no not in", values, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoBetween(String value1, String value2) {
            addCriterion("order_no between", value1, value2, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoNotBetween(String value1, String value2) {
            addCriterion("order_no not between", value1, value2, "orderNo");
            return (Criteria) this;
        }

        public Criteria andTotalDeductionPriceIsNull() {
            addCriterion("total_deduction_price is null");
            return (Criteria) this;
        }

        public Criteria andTotalDeductionPriceIsNotNull() {
            addCriterion("total_deduction_price is not null");
            return (Criteria) this;
        }

        public Criteria andTotalDeductionPriceEqualTo(BigDecimal value) {
            addCriterion("total_deduction_price =", value, "totalDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andTotalDeductionPriceNotEqualTo(BigDecimal value) {
            addCriterion("total_deduction_price <>", value, "totalDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andTotalDeductionPriceGreaterThan(BigDecimal value) {
            addCriterion("total_deduction_price >", value, "totalDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andTotalDeductionPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("total_deduction_price >=", value, "totalDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andTotalDeductionPriceLessThan(BigDecimal value) {
            addCriterion("total_deduction_price <", value, "totalDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andTotalDeductionPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("total_deduction_price <=", value, "totalDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andTotalDeductionPriceIn(List<BigDecimal> values) {
            addCriterion("total_deduction_price in", values, "totalDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andTotalDeductionPriceNotIn(List<BigDecimal> values) {
            addCriterion("total_deduction_price not in", values, "totalDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andTotalDeductionPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("total_deduction_price between", value1, value2, "totalDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andTotalDeductionPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("total_deduction_price not between", value1, value2, "totalDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andUserCouponDiscountIdIsNull() {
            addCriterion("user_coupon_discount_id is null");
            return (Criteria) this;
        }

        public Criteria andUserCouponDiscountIdIsNotNull() {
            addCriterion("user_coupon_discount_id is not null");
            return (Criteria) this;
        }

        public Criteria andUserCouponDiscountIdEqualTo(Long value) {
            addCriterion("user_coupon_discount_id =", value, "userCouponDiscountId");
            return (Criteria) this;
        }

        public Criteria andUserCouponDiscountIdNotEqualTo(Long value) {
            addCriterion("user_coupon_discount_id <>", value, "userCouponDiscountId");
            return (Criteria) this;
        }

        public Criteria andUserCouponDiscountIdGreaterThan(Long value) {
            addCriterion("user_coupon_discount_id >", value, "userCouponDiscountId");
            return (Criteria) this;
        }

        public Criteria andUserCouponDiscountIdGreaterThanOrEqualTo(Long value) {
            addCriterion("user_coupon_discount_id >=", value, "userCouponDiscountId");
            return (Criteria) this;
        }

        public Criteria andUserCouponDiscountIdLessThan(Long value) {
            addCriterion("user_coupon_discount_id <", value, "userCouponDiscountId");
            return (Criteria) this;
        }

        public Criteria andUserCouponDiscountIdLessThanOrEqualTo(Long value) {
            addCriterion("user_coupon_discount_id <=", value, "userCouponDiscountId");
            return (Criteria) this;
        }

        public Criteria andUserCouponDiscountIdIn(List<Long> values) {
            addCriterion("user_coupon_discount_id in", values, "userCouponDiscountId");
            return (Criteria) this;
        }

        public Criteria andUserCouponDiscountIdNotIn(List<Long> values) {
            addCriterion("user_coupon_discount_id not in", values, "userCouponDiscountId");
            return (Criteria) this;
        }

        public Criteria andUserCouponDiscountIdBetween(Long value1, Long value2) {
            addCriterion("user_coupon_discount_id between", value1, value2, "userCouponDiscountId");
            return (Criteria) this;
        }

        public Criteria andUserCouponDiscountIdNotBetween(Long value1, Long value2) {
            addCriterion("user_coupon_discount_id not between", value1, value2, "userCouponDiscountId");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountIdIsNull() {
            addCriterion("coupon_discount_id is null");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountIdIsNotNull() {
            addCriterion("coupon_discount_id is not null");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountIdEqualTo(Long value) {
            addCriterion("coupon_discount_id =", value, "couponDiscountId");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountIdNotEqualTo(Long value) {
            addCriterion("coupon_discount_id <>", value, "couponDiscountId");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountIdGreaterThan(Long value) {
            addCriterion("coupon_discount_id >", value, "couponDiscountId");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountIdGreaterThanOrEqualTo(Long value) {
            addCriterion("coupon_discount_id >=", value, "couponDiscountId");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountIdLessThan(Long value) {
            addCriterion("coupon_discount_id <", value, "couponDiscountId");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountIdLessThanOrEqualTo(Long value) {
            addCriterion("coupon_discount_id <=", value, "couponDiscountId");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountIdIn(List<Long> values) {
            addCriterion("coupon_discount_id in", values, "couponDiscountId");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountIdNotIn(List<Long> values) {
            addCriterion("coupon_discount_id not in", values, "couponDiscountId");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountIdBetween(Long value1, Long value2) {
            addCriterion("coupon_discount_id between", value1, value2, "couponDiscountId");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountIdNotBetween(Long value1, Long value2) {
            addCriterion("coupon_discount_id not between", value1, value2, "couponDiscountId");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountTypeIsNull() {
            addCriterion("coupon_discount_type is null");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountTypeIsNotNull() {
            addCriterion("coupon_discount_type is not null");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountTypeEqualTo(Integer value) {
            addCriterion("coupon_discount_type =", value, "couponDiscountType");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountTypeNotEqualTo(Integer value) {
            addCriterion("coupon_discount_type <>", value, "couponDiscountType");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountTypeGreaterThan(Integer value) {
            addCriterion("coupon_discount_type >", value, "couponDiscountType");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountTypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("coupon_discount_type >=", value, "couponDiscountType");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountTypeLessThan(Integer value) {
            addCriterion("coupon_discount_type <", value, "couponDiscountType");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountTypeLessThanOrEqualTo(Integer value) {
            addCriterion("coupon_discount_type <=", value, "couponDiscountType");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountTypeIn(List<Integer> values) {
            addCriterion("coupon_discount_type in", values, "couponDiscountType");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountTypeNotIn(List<Integer> values) {
            addCriterion("coupon_discount_type not in", values, "couponDiscountType");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountTypeBetween(Integer value1, Integer value2) {
            addCriterion("coupon_discount_type between", value1, value2, "couponDiscountType");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountTypeNotBetween(Integer value1, Integer value2) {
            addCriterion("coupon_discount_type not between", value1, value2, "couponDiscountType");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountPriceIsNull() {
            addCriterion("coupon_discount_price is null");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountPriceIsNotNull() {
            addCriterion("coupon_discount_price is not null");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountPriceEqualTo(BigDecimal value) {
            addCriterion("coupon_discount_price =", value, "couponDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountPriceNotEqualTo(BigDecimal value) {
            addCriterion("coupon_discount_price <>", value, "couponDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountPriceGreaterThan(BigDecimal value) {
            addCriterion("coupon_discount_price >", value, "couponDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("coupon_discount_price >=", value, "couponDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountPriceLessThan(BigDecimal value) {
            addCriterion("coupon_discount_price <", value, "couponDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("coupon_discount_price <=", value, "couponDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountPriceIn(List<BigDecimal> values) {
            addCriterion("coupon_discount_price in", values, "couponDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountPriceNotIn(List<BigDecimal> values) {
            addCriterion("coupon_discount_price not in", values, "couponDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("coupon_discount_price between", value1, value2, "couponDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("coupon_discount_price not between", value1, value2, "couponDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountActualPriceIsNull() {
            addCriterion("coupon_discount_actual_price is null");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountActualPriceIsNotNull() {
            addCriterion("coupon_discount_actual_price is not null");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountActualPriceEqualTo(BigDecimal value) {
            addCriterion("coupon_discount_actual_price =", value, "couponDiscountActualPrice");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountActualPriceNotEqualTo(BigDecimal value) {
            addCriterion("coupon_discount_actual_price <>", value, "couponDiscountActualPrice");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountActualPriceGreaterThan(BigDecimal value) {
            addCriterion("coupon_discount_actual_price >", value, "couponDiscountActualPrice");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountActualPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("coupon_discount_actual_price >=", value, "couponDiscountActualPrice");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountActualPriceLessThan(BigDecimal value) {
            addCriterion("coupon_discount_actual_price <", value, "couponDiscountActualPrice");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountActualPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("coupon_discount_actual_price <=", value, "couponDiscountActualPrice");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountActualPriceIn(List<BigDecimal> values) {
            addCriterion("coupon_discount_actual_price in", values, "couponDiscountActualPrice");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountActualPriceNotIn(List<BigDecimal> values) {
            addCriterion("coupon_discount_actual_price not in", values, "couponDiscountActualPrice");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountActualPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("coupon_discount_actual_price between", value1, value2, "couponDiscountActualPrice");
            return (Criteria) this;
        }

        public Criteria andCouponDiscountActualPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("coupon_discount_actual_price not between", value1, value2, "couponDiscountActualPrice");
            return (Criteria) this;
        }

        public Criteria andIntegralDiscountPriceIsNull() {
            addCriterion("integral_discount_price is null");
            return (Criteria) this;
        }

        public Criteria andIntegralDiscountPriceIsNotNull() {
            addCriterion("integral_discount_price is not null");
            return (Criteria) this;
        }

        public Criteria andIntegralDiscountPriceEqualTo(Long value) {
            addCriterion("integral_discount_price =", value, "integralDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andIntegralDiscountPriceNotEqualTo(Long value) {
            addCriterion("integral_discount_price <>", value, "integralDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andIntegralDiscountPriceGreaterThan(Long value) {
            addCriterion("integral_discount_price >", value, "integralDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andIntegralDiscountPriceGreaterThanOrEqualTo(Long value) {
            addCriterion("integral_discount_price >=", value, "integralDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andIntegralDiscountPriceLessThan(Long value) {
            addCriterion("integral_discount_price <", value, "integralDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andIntegralDiscountPriceLessThanOrEqualTo(Long value) {
            addCriterion("integral_discount_price <=", value, "integralDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andIntegralDiscountPriceIn(List<Long> values) {
            addCriterion("integral_discount_price in", values, "integralDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andIntegralDiscountPriceNotIn(List<Long> values) {
            addCriterion("integral_discount_price not in", values, "integralDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andIntegralDiscountPriceBetween(Long value1, Long value2) {
            addCriterion("integral_discount_price between", value1, value2, "integralDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andIntegralDiscountPriceNotBetween(Long value1, Long value2) {
            addCriterion("integral_discount_price not between", value1, value2, "integralDiscountPrice");
            return (Criteria) this;
        }

        public Criteria andExt1IsNull() {
            addCriterion("ext_1 is null");
            return (Criteria) this;
        }

        public Criteria andExt1IsNotNull() {
            addCriterion("ext_1 is not null");
            return (Criteria) this;
        }

        public Criteria andExt1EqualTo(String value) {
            addCriterion("ext_1 =", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotEqualTo(String value) {
            addCriterion("ext_1 <>", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThan(String value) {
            addCriterion("ext_1 >", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThanOrEqualTo(String value) {
            addCriterion("ext_1 >=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThan(String value) {
            addCriterion("ext_1 <", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThanOrEqualTo(String value) {
            addCriterion("ext_1 <=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Like(String value) {
            addCriterion("ext_1 like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotLike(String value) {
            addCriterion("ext_1 not like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1In(List<String> values) {
            addCriterion("ext_1 in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotIn(List<String> values) {
            addCriterion("ext_1 not in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Between(String value1, String value2) {
            addCriterion("ext_1 between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotBetween(String value1, String value2) {
            addCriterion("ext_1 not between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt2IsNull() {
            addCriterion("ext_2 is null");
            return (Criteria) this;
        }

        public Criteria andExt2IsNotNull() {
            addCriterion("ext_2 is not null");
            return (Criteria) this;
        }

        public Criteria andExt2EqualTo(String value) {
            addCriterion("ext_2 =", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotEqualTo(String value) {
            addCriterion("ext_2 <>", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThan(String value) {
            addCriterion("ext_2 >", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThanOrEqualTo(String value) {
            addCriterion("ext_2 >=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThan(String value) {
            addCriterion("ext_2 <", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThanOrEqualTo(String value) {
            addCriterion("ext_2 <=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Like(String value) {
            addCriterion("ext_2 like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotLike(String value) {
            addCriterion("ext_2 not like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2In(List<String> values) {
            addCriterion("ext_2 in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotIn(List<String> values) {
            addCriterion("ext_2 not in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Between(String value1, String value2) {
            addCriterion("ext_2 between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotBetween(String value1, String value2) {
            addCriterion("ext_2 not between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt3IsNull() {
            addCriterion("ext_3 is null");
            return (Criteria) this;
        }

        public Criteria andExt3IsNotNull() {
            addCriterion("ext_3 is not null");
            return (Criteria) this;
        }

        public Criteria andExt3EqualTo(String value) {
            addCriterion("ext_3 =", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotEqualTo(String value) {
            addCriterion("ext_3 <>", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThan(String value) {
            addCriterion("ext_3 >", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThanOrEqualTo(String value) {
            addCriterion("ext_3 >=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThan(String value) {
            addCriterion("ext_3 <", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThanOrEqualTo(String value) {
            addCriterion("ext_3 <=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Like(String value) {
            addCriterion("ext_3 like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotLike(String value) {
            addCriterion("ext_3 not like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3In(List<String> values) {
            addCriterion("ext_3 in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotIn(List<String> values) {
            addCriterion("ext_3 not in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Between(String value1, String value2) {
            addCriterion("ext_3 between", value1, value2, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotBetween(String value1, String value2) {
            addCriterion("ext_3 not between", value1, value2, "ext3");
            return (Criteria) this;
        }
    }

    /**
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}